//
// G.M. Subelack.
//
//gmsubelack@zonnet.nl
//
// Have funn.



Unit SlideBar;

Interface
              
Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ComCtrls, CommCtrl, ExtCtrls, Math;

Type
    TChangeEvent = Procedure (Position : Integer; Sender: TObject) Of Object;
    TSlideBarOrientation = (trHorizontal, trVertical);
Type
    TSlideBar            = Class(TCustomPanel)
  Private
    { Private declarations }
    FOrientation     : TSlideBarOrientation;
    FOnChange        : TChangeEvent;
    FOnMouseDown     : TMouseEvent;
    FOnMouseUp       : TMouseEvent;
    FOnMouseMove     : TMouseMoveEvent;
    FPosition        : Integer;
    FFrequency       : Integer;
    FPageSize        : Integer;
    ClientPanel      : TPanel;
    BgImage,
    ButtonImage        : TImage;
    FMin: Integer;
    FMax: Integer;
    XPos             : Integer;
    YPos             : Integer;
    MUp              : Bool;
    procedure CNHScroll(Var Message: TWMHScroll); Message CN_HSCROLL;
    procedure CNVScroll(Var Message: TWMVScroll); Message CN_VSCROLL;
    Procedure SetOrientation(Value: TSlideBarOrientation);
    procedure SetParams(APosition, AMin, AMax: Integer);
    procedure SetImagePosition;
    procedure SetPosition(Value: Integer);
    procedure SetMin(Value: Integer);
    procedure SetMax(Value: Integer);
    procedure SetFrequency(Value: Integer);
    procedure SetPageSize(Value: Integer);
  Protected
    { Protected declarations }
    procedure CreateParams(Var Params: TCreateParams); Override;
    procedure CreateWnd; Override;
    procedure SetBtnGlyph(Value: TBitmap);
    procedure SetBgGlyph(Value: TBitmap);
    function  GetBtnGlyph: TBitmap;
    function  GetBgGlyph: TBitmap;
    function  HasPicture(Image : TImage): Bool;
    Procedure Mouse_Down(Sender:TObject; Button:TMouseButton; ShIft:TShiftState; X,Y: Integer);
    Procedure Mouse_Move(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Mouse_Up(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    Procedure Resize;                         Override;
    procedure RotateBitmap(Image : TImage);
  Public
    { Public declarations }
    constructor Create(AOwner: TComponent);     Override;
  Published
    { Published declarations }
    Property DragCursor;
    Property DragMode;
    Property Enabled;
    property Orientation: TSlideBarOrientation Read FOrientation Write SetOrientation;
    property Max: Integer Read FMax Write SetMax Default 10;
    property Min: Integer Read FMin Write SetMin Default 0;
    property Position: Integer Read FPosition Write SetPosition;
    property ButtonGlyph: TBitmap Read  GetBtnGlyph Write SetBtnGlyph;
    property BGroundGlyph: TBitmap Read  GetBgGlyph Write SetBgGlyph;
    property Frequency: Integer Read  FFrequency Write SetFrequency;
    Property ParentCtl3D;
    Property ParentShowHint;
    property PageSize: Integer Read FPageSize Write SetPageSize Default 2;
    Property PopupMenu;
    Property ShowHint;
    Property TabOrder;
    Property TabStop;
    Property Visible;
    Property OnChange: TChangeEvent Read FOnChange Write FOnChange;
    Property OnDragDrop;
    Property OnDragOver;
    Property OnEndDrag;
    Property OnEnter;
    Property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    Property OnStartDrag;
    Property OnMouseDown: TMouseEvent Read FOnMouseDown Write FOnMouseDown;
    Property OnMouseMove: TMouseMoveEvent Read FOnMouseMove Write FOnMouseMove;
    Property OnMouseUp: TMouseEvent Read FOnMouseUp Write FOnMouseUp;
    Property Height;
    Property Width;
  End;

 Procedure Register;

Implementation

Procedure Register;
Begin
  RegisterComponents('YourStuff', [TSlideBar]);
End;
///////////////////////////////////////////////////////////////////////////////
// Create all the visible items
// Set the Owner and Parent properties so Delphi deletes them all for us.
///////////////////////////////////////////////////////////////////////////////
Constructor TSlideBar.Create(AOwner: TComponent);
Begin
  Inherited;
  ControlStyle := ControlStyle - [csSetCaption] - [csDoubleClicks];
  Width                         := 120;
  Height                        := 12;
  TabStop                       := True;
  FMin                          := 0;
  FMax                          := 10;
  FPageSize                     := 2;
  FFrequency                    := 1;
  FOrientation                  := trHorizontal;
  BevelInner                    := bvNone;
  BevelOuter                    := bvNone;

  ClientPanel                   := TPanel.Create(Self);
  ClientPanel.Parent            := Self;
  ClientPanel.Align             := AlClient;
  ClientPanel.BevelInner        := bvNone;
  ClientPanel.BevelOuter        := bvNone;
  ClientPanel.Color             := clWhite;
  ClientPanel.Visible           := True;

  BgImage                       := TImage.Create(ClientPanel);
  BgImage.Parent                := ClientPanel;
  BgImage.Visible               := True;
  BgImage.Align                 := AlClient;
  BgImage.OnMouseMove           := Mouse_Move;
  BgImage.OnMouseDown           := Mouse_Down;
  BgImage.OnMouseUp             := Mouse_Up;
  BgImage.Stretch               := True;

  ButtonImage                   := TImage.Create(ClientPanel);
  ButtonImage.Parent            := ClientPanel;
  ButtonImage.Visible           := True;
  ButtonImage.Align             := alNone;
  ButtonImage.Height            := Width;
  ButtonImage.Width             := ButtonImage.Height;
  ButtonImage.OnMouseMove       := Mouse_Move;
  ButtonImage.OnMouseDown       := Mouse_Down;
  ButtonImage.OnMouseUp         := Mouse_Up;
  ButtonImage.Stretch           := True;
  SetParams(0, 0, 10);
End;
///////////////////////////////////////////////////////////////////////////////
// Adjust everythIng after a resize
///////////////////////////////////////////////////////////////////////////////
Procedure TSlideBar.Resize;
Var
Pcent : Extended;
Begin
  Inherited;
If FOrientation = trHorizontal Then
Begin
  ButtonImage.Top                 :=0;
  ButtonImage.Height              := Height;
  ButtonImage.Width               := ButtonImage.Height;
  If HasPicture(ButtonImage) Then
  Pcent := ButtonImage.Picture.Width / ButtonImage.Picture.Height
  Else
  Pcent := 1;
  ButtonImage.Height              := Height;
  ButtonImage.Width               := Round(Pcent * ButtonImage.Height);
  end
  Else
  Begin
  ButtonImage.Left                :=0;
  ButtonImage.Width               := Width;
  ButtonImage.Height              := ButtonImage.Width;
  If HasPicture(BgImage) Then
  Pcent := ButtonImage.Picture.Height / ButtonImage.Picture.Width
  Else
  Pcent := 1;
  ButtonImage.Width               := Width;
  ButtonImage.Height              := Round(Pcent * ButtonImage.Width);
  end;
 SetParams(FPosition, FMin, FMax);
 SetImagePosition;
End;
///////////////////////////////////////////////////////////////////////////////
// Events we pass on to user
///////////////////////////////////////////////////////////////////////////////
procedure TSlideBar.CNHScroll(Var Message: TWMHScroll);
Begin
  Inherited;
  FPosition := SendMessage(Handle, TBM_GETPOS, 0, 0);
  SetImagePosition;
  Message.Result := 0;
End;

procedure TSlideBar.CNVScroll(Var Message: TWMVScroll);
Begin
  Inherited;
  FPosition := SendMessage(Handle, TBM_GETPOS, 0, 0);
  SetImagePosition;
  Message.Result := 0;
End;

procedure TSlideBar.CreateParams(Var Params: TCreateParams);
const
  OrientationStyle: Array[TSlideBarOrientation] Of Longint = (TBS_HORZ, TBS_VERT);
Begin
  InitCommonControl(ICC_BAR_CLASSES);
  Inherited CreateParams(Params);
  CreateSubClass(Params, TRACKBAR_CLASS);
  With Params Do
  Begin
    Style := Style Or OrientationStyle[FOrientation] And
    Not TBS_ENABLESELRANGE;
  End;
End;

procedure TSlideBar.CreateWnd;
begin
Inherited CreateWnd;
If HandleAllocated Then
Begin
SendMessage(Handle, TBM_SETPAGESIZE, 0, FPageSize);
SendMessage(Handle, TBM_SETRANGEMIN, 0, FMin);
SendMessage(Handle, TBM_SETRANGEMAX, 0, FMax);
SendMessage(Handle, TBM_SETPOS, 1, FPosition);
SendMessage(Handle, TBM_SETTICFREQ, FFrequency, 1);
End;
End;

procedure TSlideBar.SetOrientation(Value: TSlideBarOrientation);
begin
If Value <> FOrientation Then
Begin
FOrientation := Value;
If ComponentState * [csLoading, csUpdating] = [] Then
Begin
SetBounds(Left, Top, Height, Width);
If HasPicture(BgImage) Then
RotateBitmap(BgImage);
If HasPicture(ButtonImage) Then
RotateBitmap(ButtonImage);
end;
RecreateWnd;
End;
end;

procedure TSlideBar.SetParams(APosition, AMin, AMax: Integer);
Begin
  If AMax < AMin Then
    Raise EInvalidOperation.CreateFmt('Property out of range.', [Self.Classname]);
  If APosition < AMin Then APosition := AMin;
  If APosition > AMax Then APosition := AMax;
  If (FMin <> AMin) Then
  Begin
    FMin := AMin;
    If HandleAllocated Then
      SendMessage(Handle, TBM_SETRANGEMIN, 1, AMin);
  End;
  If (FMax <> AMax) Then
  Begin
    FMax := AMax;
    If HandleAllocated Then
      SendMessage(Handle, TBM_SETRANGEMAX, 1, AMax);
  End;
  If FPosition <> APosition Then
  FPosition := APosition;
SetImagePosition;
End;

procedure TSlideBar.SetPosition(Value: Integer);
begin
SetParams(Value, FMin, FMax);
end;

procedure TSlideBar.SetMin(Value: Integer);
begin
SetParams(FPosition, Value, FMax);
end;

procedure TSlideBar.SetMax(Value: Integer);
begin
SetParams(FPosition, FMin, Value);
End;

procedure TSlideBar.SetFrequency(Value: Integer);
begin
If Value <> FFrequency then
Begin
FFrequency := Value;
If HandleAllocated Then
SendMessage(Handle, TBM_SETTICFREQ, FFrequency, 1);
End;
End;

procedure TSlideBar.SetPageSize(Value: Integer);
begin
If Value <> FPageSize Then
Begin
FPageSize := Value;
If HandleAllocated Then
SendMessage(Handle, TBM_SETPAGESIZE, 0, FPageSize);
End;
End;

///////////////////////////////////////////////////////////////////////////////
// Image Handling
///////////////////////////////////////////////////////////////////////////////
procedure TSlideBar.RotateBitmap(Image : TImage);
Type
pRGBArray  =  ^TRGBArray;
TRGBArray  =  ARRAY[0..32767] OF TRGBTriple;
Var
DestRow : pRGBArray;
Ang, SinAng, CosAng, Xori, Yori, XRot, YRot, DX, DY, CX, CY,
TmpHSIN, TmpWSIN, dPP, dPPAngle : Extended;
TmpAngle, Angle, I, J : Integer;
OrgBitMap, BitMap : TBitmap;
Color : TColor;
Begin

BitMap := TBitMap.Create;
Bitmap.PixelFormat := pf24bit;
Bitmap.Width := Image.Picture.Width;
Bitmap.Height := Image.Picture.Height;
Bitmap.Canvas.Draw(0, 0, Image.Picture.Graphic);
Color := Bitmap.Canvas.Pixels[0,Bitmap.Height-1];
BitMap.Free;
    BitMap := TBitmap.Create;
    OrgBitmap := TBitmap.Create;
Try
    Bitmap.PixelFormat := pf24bit;
    OrgBitmap.PixelFormat := pf24bit;
    OrgBitmap.Width := Image.Picture.Width + 8;
    OrgBitmap.Height := Image.Picture.Height + 8;
  With OrgBitmap.Canvas Do
  Begin
    Brush.Color := Color;
    Brush.Style := bsSolid;
    FillRect(ClipRect);
  End;
    OrgBitmap.Canvas.Draw(0, 0, Image.Picture.Graphic);
    Angle := 90;
If ((Angle >= 0) And (Angle <= 90)) Or
   ((Angle > 180) And (Angle <= 270)) Then
Begin
If Angle > 180 then
TmpAngle := Angle -180
Else
TmpAngle := Angle;

    dPP := Sqrt(Sqr(OrgBitmap.Width-8) + Sqr(OrgBitmap.Height-8));
    dPPAngle := ArcTan((OrgBitmap.Height-8) / (OrgBitmap.Width-8)) / (PI / 180);
    TmpHSIN := Sin(((90 - TmpAngle) + dPPAngle) * (PI / 180));
    TmpWSIN := Sin((TmpAngle + dPPAngle) * (PI / 180));
End
Else
Begin
If Angle > 270 then
TmpAngle := Angle -180
Else
TmpAngle := Angle;

    dPP := Sqrt(Sqr(OrgBitmap.Width-8) + Sqr(OrgBitmap.Height-8));
    dPPAngle := ArcTan((OrgBitmap.Height-8) / (OrgBitmap.Width-8)) /(PI / 180);
    TmpHSIN := Sin(((TmpAngle - 90) + dPPAngle) * (PI / 180));
    TmpWSIN := Sin(((180 - TmpAngle) + dPPAngle) * (PI / 180));
    End;

BitMap.Width := Round(TmpHSIN * dPP);
BitMap.Height := Round(TmpWSIN * dPP);

With BitMap.Canvas Do
  begin
    Brush.Color := Color;
    Brush.Style := bsSolid;
    FillRect(ClipRect);
  end;

    CX := (OrgBitmap.Width-8) Div 2;
    CY := (OrgBitmap.Height-8) Div 2;
    DX := BitMap.Width Div 2;
    DY := BitMap.Height Div 2;

    Ang := DegToRad(Angle);
    SinCos(Ang, SinAng, CosAng);
    For I := 0 To BitMap.Height Do
    begin
    DestRow := BitMap.ScanLine[I];

    For J := 0 To BitMap.Width Do
     begin
     Xori := J - DX;
     Yori := I - DY;
     XRot := (Xori * CosAng) - (Yori * SinAng) + CX;
     YRot := (Xori * SinAng) + (Yori * CosAng) + CY;

     If (XRot >= 0) And (XRot <= OrgBitmap.Width-8) And
     (YRot >= 0) And (YRot <= OrgBitmap.Height-8) Then
     Try
   DestRow[J] := pRGBArray(OrgBitmap.ScanLine[Round(YRot)])[Round(XRot)];
   Except end;
    end;
  end;
   Image.Picture.Assign(Nil);
   Image.Picture.Assign(BitMap);
   Finally
   BitMap.Free;
   OrgBitmap.Free;
   end;
end;

procedure TSlideBar.SetImagePosition;
Var
Resolution : Real;
Begin
If FMin < 0 Then
Resolution := (ClientPanel.Width-ButtonImage.Width) / (FMax + Abs(FMin))
Else
Resolution := (ClientPanel.Width-ButtonImage.Width) / (FMax - FMin);

 If FOrientation = trHorizontal Then
 Begin
 If FMin >= 0 Then
 ButtonImage.Left := Round((FPosition -Abs(FMin)) * Resolution)
 Else
 ButtonImage.Left := Round((FPosition +Abs(FMin)) * Resolution);
 end;

If FMin < 0 Then
Resolution := (ClientPanel.Height-ButtonImage.Height) / (FMax + Abs(FMin))
Else
Resolution := (ClientPanel.Height-ButtonImage.Height) / (FMax - FMin);

 If FOrientation = trVertical Then
 Begin
 If FMin >= 0 Then
 ButtonImage.Top := Round((FPosition -Abs(FMin)) * Resolution)
 Else
 ButtonImage.Top := Round((FPosition +Abs(FMin)) * Resolution);
 end;

If HandleAllocated Then
SendMessage(Handle, TBM_SETPOS, 1, FPosition);

If Assigned(FOnChange) Then
 FOnChange(FPosition,Self);
end;

procedure TSlideBar.SetBtnGlyph(Value: TBitmap);
Begin
  ButtonImage.Picture.Bitmap := Value;
  Resize;
End;

procedure TSlideBar.SetBgGlyph(Value: TBitmap);
begin
  BgImage.Picture.Bitmap := Value;
  Resize;
end;

function TSlideBar.GetBtnGlyph: TBitmap;
begin
Result := ButtonImage.Picture.Bitmap;
 Resize;
end;

function TSlideBar.GetBgGlyph: TBitmap;
begin
Result := BgImage.Picture.Bitmap;
Resize;
end;

function TSlideBar.HasPicture(Image : TImage): Bool;
Begin
Result := Image.Picture.Bitmap.Handle <> 0;
end;

Procedure TSlideBar.Mouse_Down(Sender:TObject; Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
Begin
SetFocus;
If ssLeft In Shift Then
Begin
MUp := False;
XPos := X;
YPos := Y;
If Sender = BgImage Then
Repeat
If FOrientation = trHorizontal Then
Begin
If ButtonImage.Left < X Then
FPosition := FPosition + PageSize
Else
FPosition := FPosition - PageSize;
end;

If FOrientation = trVertical Then
Begin
If ButtonImage.Top < Y Then
FPosition := FPosition + PageSize
Else
FPosition := FPosition - PageSize;
end;
SetParams(FPosition, FMin, FMax);
Sleep(500);
Application.ProcessMessages;
Until MUp;
end;
If Assigned(FOnMouseDown) Then FOnMouseDown(Sender,Button,Shift,X,Y);
End;

Procedure TSlideBar.Mouse_Move(Sender: TObject; Shift: TShiftState; X, Y: Integer);
Var
Z : Integer;
Begin
ButtonImage.Cursor := Cursor;
If FMin < 0 Then
Z := FMax + Abs(FMin)
Else
Z := FMax - FMin;

If ssLeft In Shift Then
Begin
If (Sender = ButtonImage) And (FOrientation = trHorizontal) Then
Begin
ButtonImage.Left := (ButtonImage.Left - XPos)+ X;
If ButtonImage.Left < 0 Then
ButtonImage.Left := 0;
If ButtonImage.Left > Width - ButtonImage.Width Then
ButtonImage.Left := Width - ButtonImage.Width;
Try
FPosition := Round(FMin +(ButtonImage.Left /((Width-ButtonImage.Width) / Z)));
Except FPosition := FMin; End;
end;

If (Sender = ButtonImage) And (FOrientation = trVertical) Then
Begin
ButtonImage.Top := (ButtonImage.Top - YPos)+ Y;
If ButtonImage.Top < 0 Then
ButtonImage.Top := 0;
If ButtonImage.Top > Height - ButtonImage.Height Then
ButtonImage.Top := Height - ButtonImage.Height;
Try
FPosition := Round(FMin +(ButtonImage.Top /((Height-ButtonImage.Height) / Z)));
Except FPosition := FMin; End;
end;

If Assigned(FOnChange) Then FOnChange(FPosition,Sender);
SendMessage(Handle, TBM_SETPOS, 1, FPosition);
end;
If Assigned(FOnMouseMove) Then FOnMouseMove(Sender,Shift,X,Y);
End;

procedure TSlideBar.Mouse_Up(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
MUp := True;
If Assigned(FOnMouseUp) Then FOnMouseUp(Sender,Button,Shift,X,Y);
end;

End.
